;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
Menu_Up:
	ld a,(currentItem)
	or a
	jr nz,Menu_Up_OK
	ld a,(lastItem)
Menu_Up_OK:
	dec a
Menu_UpDown_Go:
	ld (currentItem),a
	call Highlight_Item
	jr FunctionsMenu_Loop
Menu_Down:
	ld a,(lastItem)
	ld b,a
	dec b
	ld a,(currentItem)
	cp b
	jr nz,Menu_Down_OK
	ld a,0FFh
Menu_Down_OK:
	inc a
	jr Menu_UpDown_Go
Menu_Select:
	call Textshadow_Show
	set appTextSave,(iy+appFlags)
	ld hl,(backupcursor)
	ld (currow),hl
	bit flagInputActive,(iy+asm_Flag1)
	call nz,Parse_Ret
	res flagInputActive,(iy+asm_Flag1)
	ld a,(currentItem)
	add a,a
	ld hl,(menupointer)
	ld d,0
	ld e,a
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	ld b,(hl)
	inc hl
	ld a,(rpnEntryCount)
	cp b
	jp c,StackError
	jp (hl)
FunctionsMenu:
	;Show the functions menu
	ld bc,(currow)
	ld (backupcursor),bc
	res appTextSave,(iy+appFlags)
	B_CALL CursorOff
	ld a,(Function_Menu)
	ld (maxMenu),a
	xor a
	ld (currentMenu),a
	call Menu_Display
FunctionsMenu_Loop:
	B_CALL GetKey
	cp 40h
	jr z,FunctionsMenu_Exit
	cp kClear
	jr z,FunctionsMenu_Exit
	cp kDown
	jr z,Menu_Down
	cp kUp
	jp z,Menu_Up
	cp kRight
	jr z,Menu_Right
	cp kLeft
	jr z,Menu_Left
	cp kEnter
	jr z,Menu_Select
	cp 8Fh
	jr c,FunctionsMenu_Loop
	cp 96h
	jr nc,FunctionsMenu_Loop
	;Numeric key pressed
	sub 8Eh
	ld b,a
	ld a,(lastItem)
	cp b
	jr c,FunctionsMenu_Loop
	ld a,b
	dec a
	ld (currentItem),a
	jp Menu_Select
Menu_Left:
	ld a,(currentMenu)
	or a
	jr nz,Menu_Left_OK
	ld a,(maxMenu)
Menu_Left_OK:
	dec a
Menu_LeftRight_Go:
	ld (currentMenu),a
	call Menu_Display
	jr FunctionsMenu_Loop
Menu_Right:
	ld a,(maxMenu)
	ld b,a
	dec b
	ld a,(currentMenu)
	cp b
	jr nz,Menu_Right_OK
	ld a,0FFh
Menu_Right_OK:
	inc a
	jr Menu_LeftRight_Go
FunctionsMenu_Exit:
	bit flagInputActive,(iy+asm_Flag1)
	jp z,Interface_Next
	;Input was active...resume it
	call Textshadow_Show
	set appTextSave,(iy+appFlags)
	ld hl,(backupcursor)
	ld (currow),hl
	B_CALL CursorOn
	jp Interface_Input
Highlight_Item:
	ld a,(lastItem)
	ld b,a
	ld a,(currentItem)
	ld de,1
	ld (currow),de
	;D is 0
	;E is the current item
	ld e,a
	ld hl,Menu_Template
Highlight_Item_Loop:
	ld a,e
	cp d
	jr nz,Highlight_Item_Normal
	set textInverse,(iy+textFlags)
Highlight_Item_Normal:
	ld a,(hl)
	B_CALL PutC
	ld a,':'
	B_CALL PutC
	inc hl
	res textInverse,(iy+textFlags)
	push hl
	ld hl,currow
	inc (hl)
	inc hl
	ld (hl),0
	pop hl
	inc d
	ld a,d
	cp b
	jr nz,Highlight_Item_Loop
	ret
Menu_Display:
	B_CALL ClrLCDFull
	ld bc,(currentMenu)
	;C is currentMenu, B is maxMenu
	ld a,b
	add a,a
	ld d,0
	ld e,a
	ld hl,Function_Menu+1
	push hl
	add hl,de
	ld de,0
	ld (currow),de
	;E is 0
Menu_Display_Loop:
	ld a,e
	cp c
	jr nz,Menu_Display_Loop_Normal
	set textInverse,(iy+textFlags)
Menu_Display_Loop_Normal:
	call putstr
	res textInverse,(iy+textFlags)
	ld a,' '
	B_CALL PutC
	inc e
	ld a,e
	cp b
	jr nz,Menu_Display_Loop
	;Now...display the items
	ld a,c
	add a,a
	pop hl
	ld e,a
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	;HL points to the menu's structure
	xor a
	ld (currentItem),a
	ld a,(hl)
	inc hl
	ld (menupointer),hl
	ld b,a
	ld (lastItem),a
	add a,a
	ld d,0
	ld e,a
	add hl,de
	ld e,1
	ld (currow),de
	ld de,Menu_Template
Menu_Display_Loop2:
	ex de,hl
	ld a,(hl)
	B_CALL PutC
	inc hl
	ld a,':'
	B_CALL PutC
	ex de,hl
	call putstr
	B_CALL EraseEOL
	push hl
	ld hl,currow
	inc (hl)
	inc hl
	ld (hl),0
	pop hl
	djnz Menu_Display_Loop2
	jp Highlight_Item
Function_Menu:
	DB 2
	DW Menu_Number
	DW Menu_Probability
	DB "NUM",0
	DB "PROB",0
Menu_Number:
	DB 6
	DW Misc_SquareRoot
	DW Misc_Modulus
	DW Number_IsPrime
	DW Misc_GCD
	DW Misc_LCM
	DW Misc_Log
	DB 10h,0
	DB "mod",0
	DB "isPrime",0
	DB "gcd",0
	DB "lcm",0
	DB "logb",0
Menu_Template:
	DB "123456"
Menu_Probability:
	DB 3
	DW Probability_Factorial
	DW Probability_Permutation
	DW Probability_Combination
	DB "!",0
	DB "nPr",0
	DB "nCr",0
Misc_Modulus:
	DB 2
	call Parse_TwoNumber_Start
	call BCD_Division
	ex de,hl
	jp Parse_TwoValue_End
Number_IsPrime:
	DB 1
	call Parse_OneNumber_Start
	jp IsPrime
Probability_Factorial:
	DB 1
	call Parse_OneNumber_Start
	call Factorial
	jp Parse_OneValue_End
Probability_Permutation:
	DB 2
	call Parse_TwoNumber_Start
	call Permutation
	jp Parse_TwoValue_End
Probability_Combination:
	DB 2
	call Parse_TwoNumber_Start
	call Combination
	jp Parse_TwoValue_End
Misc_GCD:
	DB 2
	call Parse_TwoNumber_Start
	call GCD
	jp Parse_TwoValue_End
Misc_LCM:
	DB 2
	call Parse_TwoNumber_Start
	call LCM
	jp Parse_TwoValue_End
Misc_SquareRoot:
	DB 1
	call Parse_OneNumber_Start
	call Square_Root
	jp Parse_OneValue_End
Misc_Log:
	DB 2
	call Parse_TwoNumber_Start
	call Log
	jp Parse_TwoValue_End
Textshadow_Show:
	ld hl,0
	ld (currow),hl
	ld hl,textshadow
	ld b,128
FunctionsMenu_Restore_Loop:
	ld a,(hl)
	B_CALL PutC
	inc hl
	djnz FunctionsMenu_Restore_Loop
	ret
